package com.adventurer_engine.client.model;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import atv;
import bbo;
import bjo;
import bjp;
import com.adventurer_engine.client.model.tmt.ModelRendererTurbo;
import com.adventurer_engine.util.DebugGadgets;
import com.adventurer_engine.util.JsonHelper;
import java.io.InputStreamReader;
import java.util.List;

public class ItemModelBaked extends bbo {
  ModelRendererTurbo[] parts;
  
  public final bjo texture;
  
  public float modelScale;
  
  public JsonHelper thirdPerson_righthand;
  
  public JsonHelper firstPerson_righthand;
  
  public JsonHelper ground;
  
  private static final int otto = 16;
  
  public ItemModelBaked(bjo jsonFile, bjo texture) {
    this.texture = texture;
    this.modelScale = 1.0F;
    try {
      bjp s = atv.w().K();
      InputStreamReader as = new InputStreamReader(s.a(jsonFile).b());
      JsonHelper json = new JsonHelper(as);
      List<Double> texture_size = json.getList("texture_size");
      resolveCube(json.getJsonList("elements"), ((Double)texture_size.get(0)).intValue(), ((Double)texture_size.get(1)).intValue());
      JsonHelper display = json.getSubJson("display");
      this.thirdPerson_righthand = display.getSubJson("thirdperson_righthand");
      this.firstPerson_righthand = display.getSubJson("firstperson_righthand");
      this.ground = display.getSubJson("ground");
      json.close();
    } catch (Exception ignored) {
      ignored.printStackTrace(DebugGadgets.debugFile);
    } 
  }
  
  public void renderItem(float f) {
    for (ModelRendererTurbo renderer : this.parts) {
      if (renderer != null)
        renderer.a(f); 
    } 
  }
  
  private void resolveCube(List<JsonHelper> element, int textureSizeX, int textureSizeY) {
    this.parts = new ModelRendererTurbo[element.size()];
    float o0 = 0.0F;
    for (int i = 0; i < this.parts.length; i++) {
      JsonHelper cube = element.get(i);
      List<Double> from = cube.getList("from");
      List<Double> to = cube.getList("to");
      JsonHelper faces = cube.getSubJson("faces");
      JsonHelper rotation = cube.getSubJson("rotation");
      float angle = rotation.getFloat("angle");
      String axis = rotation.getString("axis");
      List<Double> origin = rotation.getList("origin");
      JsonHelper east = faces.getSubJson("east");
      JsonHelper up = faces.getSubJson("up");
      List<Double> east_uv = east.getList("uv");
      List<Double> up_uv = up.getList("uv");
      float ox = ((Double)from.get(0)).floatValue();
      float oy = ((Double)from.get(1)).floatValue();
      float oz = ((Double)from.get(2)).floatValue();
      float px = ((Double)origin.get(0)).floatValue();
      float py = ((Double)origin.get(1)).floatValue();
      float pz = ((Double)origin.get(2)).floatValue();
      float ex = ((Double)to.get(0)).floatValue() - ox;
      float ey = ((Double)to.get(1)).floatValue() - oy;
      float ez = ((Double)to.get(2)).floatValue() - oz;
      int dx = (int)ex;
      int dy = (int)ey;
      int dz = (int)ez;
      ex -= dx;
      ey -= dy;
      ez -= dz;
      int tx = (int)(((Double)east_uv.get(0)).doubleValue() * (textureSizeX / 16));
      int ty = (int)(((Double)up_uv.get(3)).doubleValue() * (textureSizeX / 16));
      float rx = "x".equals(axis) ? (float)((angle / 180.0F) * Math.PI) : o0;
      float ry = "y".equals(axis) ? (float)((angle / 180.0F) * Math.PI) : o0;
      float rz = "z".equals(axis) ? (float)(-(angle / 180.0F) * Math.PI) : o0;
      ox -= px;
      oy -= py;
      oz -= pz;
      this.parts[i] = new ModelRendererTurbo(this, tx, ty, textureSizeX, textureSizeY);
      this.parts[i].addShapeBox(ox, oy, oz, dx, dy, dz, 0.0F, -dx, -dy, o0, -ex - dx, -dy, o0, -ex - dx, -dy, ez, -dx, -dy, ez, -dx, -ey - dy, o0, -ex - dx, -ey - dy, o0, -ex - dx, -ey - dy, ez, -dx, -ey - dy, ez);
      this.parts[i].a(px, py, pz);
      (this.parts[i]).f = rx;
      (this.parts[i]).g = ry;
      (this.parts[i]).h = rz;
    } 
  }
}
